# Class ModuleApplication<M, O>

#### Type Parameters

- M
- O extends ModuleApplicationConfig

#### Hierarchy (view full)

- Application<O, NgModuleRef<M>>
  - ModuleApplication

- Defined in lib/module-application.ts:18

#####
Index

### Constructors

constructor

### Properties

app
config
configLoadOptions?
environment
logger
moduleType
options

### Methods

after
before
bootstrap
create
handleAfter
handleBefore
loadConfig
prepareConfig
prepareEnvironment

## Constructors

### constructor

- new ModuleApplication<M, O>(environment, moduleType, options?, configLoadOptions?): ModuleApplication<M, O>

- #### Type Parameters

  - M
  - O extends ModuleApplicationConfig

  #### Parameters

  - environment: Environment
  - moduleType: Type<M>
  - `Optional` options: O
  - `Optional` configLoadOptions: ConfigLoadOptions

  #### Returns ModuleApplication<M, O>

  Overrides Application.constructor

  - Defined in lib/module-application.ts:20

## Properties

### app

app: null | NgModuleRef<M> = null

Inherited from Application.app

- Defined in lib/application.ts:35

### config

config: null | ConfigService<Record<string, any>> = null

Inherited from Application.config

- Defined in lib/application.ts:37

### `Optional` `Readonly` configLoadOptions

configLoadOptions?: ConfigLoadOptions

Inherited from Application.configLoadOptions

- Defined in lib/application.ts:44

### `Readonly` environment

environment: Environment

Inherited from Application.environment

- Defined in lib/application.ts:42

### logger

logger: null | NGXLogger = null

Inherited from Application.logger

- Defined in lib/application.ts:36

### `Private` `Readonly` moduleType

moduleType: Type<M>

- Defined in lib/module-application.ts:22

### `Readonly` options

options: O = ...

Inherited from Application.options

- Defined in lib/application.ts:43

## Methods

### after

- after(fnc): void

- #### Parameters

  - fnc: ApplicationAfterFunction<NgModuleRef<M>>

  #### Returns void

  Inherited from Application.after

  - Defined in lib/application.ts:86

### before

- before(fnc): void

- #### Parameters

  - fnc: ApplicationBeforeFunction<O>

  #### Returns void

  Inherited from Application.before

  - Defined in lib/application.ts:82

### bootstrap

- bootstrap(): Promise<void>

- #### Returns Promise<void>

  Inherited from Application.bootstrap

  - Defined in lib/application.ts:47

### `Protected` create

- create(): Promise<NgModuleRef<M>>

- #### Returns Promise<NgModuleRef<M>>

  Overrides Application.create

  - Defined in lib/module-application.ts:29

### `Protected` handleAfter

- handleAfter(app, logger, config): Promise<void>

- #### Parameters

  - app: NgModuleRef<M>
  - logger: NGXLogger
  - config: ConfigService<Record<string, any>>

  #### Returns Promise<void>

  Inherited from Application.handleAfter

  - Defined in lib/application.ts:96

### `Protected` handleBefore

- handleBefore(config, options): Promise<void>

- #### Parameters

  - config: ConfigService<Record<string, any>>
  - options: O

  #### Returns Promise<void>

  Inherited from Application.handleBefore

  - Defined in lib/application.ts:90

### `Protected` loadConfig

- loadConfig(environment): Promise<void>

- #### Parameters

  - environment: Environment

  #### Returns Promise<void>

  Inherited from Application.loadConfig

  - Defined in lib/application.ts:102

### `Protected` prepareConfig

- prepareConfig(config): void

- #### Parameters

  - config: O

  #### Returns void

  Overrides Application.prepareConfig

  - Defined in lib/module-application.ts:34

### `Protected` prepareEnvironment

- prepareEnvironment(environment): Promise<void>

- #### Parameters

  - environment: Environment

  #### Returns Promise<void>

  Inherited from Application.prepareEnvironment

  - Defined in lib/application.ts:106